osgParticle::BounceOperator Class Reference

`#include <BounceOperator>`

Inheritance diagram for osgParticle::BounceOperator:

## Public Member Functions

| BounceOperator ()
| BounceOperator (const BounceOperator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, BounceOperator)
void | setFriction (float f)
| Set the friction.
float | getFriction () const
| Get the friction.
void | setResilience (float r)
| Set the resilience.
float | getResilience () const
| Get the velocity cutoff factor.
void | setCutoff (float v)
| Set the velocity cutoff factor.
float | getCutoff () const
| Get the velocity cutoff factor.
Public Member Functions inherited from osgParticle::DomainOperator
| DomainOperator ()
| DomainOperator (const DomainOperator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, DomainOperator)
void | addPointDomain (const osg::Vec3 &p)
| Add a point domain.
void | addLineSegmentDomain (const osg::Vec3 &v1, const osg::Vec3 &v2)
| Add a line segment domain.
void | addTriangleDomain (const osg::Vec3 &v1, const osg::Vec3 &v2, const osg::Vec3 &v3)
| Add a triangle domain.
void | addRectangleDomain (const osg::Vec3 &corner, const osg::Vec3 &w, const osg::Vec3 &h)
| Add a rectangle domain.
void | addPlaneDomain (const osg::Plane &plane)
| Add a plane domain.
void | addSphereDomain (const osg::Vec3 &c, float r)
| Add a sphere domain.
void | addBoxDomain (const osg::Vec3 &min, const osg::Vec3 &max)
| Add a box domain.
void | addDiskDomain (const osg::Vec3 &c, const osg::Vec3 &n, float r1, float r2=0.0f)
| Add a disk domain.
void | addDomain (const Domain &domain)
| Add a domain object directly, used by the .osg wrappers and serializers.
const Domain & | getDomain (unsigned int i) const
| Get a domain object directly, used by the .osg wrappers and serializers.
void | removeDomain (unsigned int i)
| Remove a domain at specific index.
void | removeAllDomains ()
| Remove all existing domains.
unsigned int | getNumDomains () const
| Get number of domains.
void | operate (Particle *P, double dt)
| Apply the acceleration to a particle. Do not call this method manually.
void | beginOperate (Program *prg)
| Perform some initializations. Do not call this method manually.
void | endOperate ()
| Perform some post-operations. Do not call this method manually.
Public Member Functions inherited from osgParticle::Operator
| Operator ()
| Operator (const Operator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
bool | isEnabled () const
| Get whether this operator is enabled.
void | setEnabled (bool v)
| Enable or disable this operator.
virtual void | operateParticles (ParticleSystem *ps, double dt)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~BounceOperator ()
BounceOperator & | operator= (const BounceOperator &)
virtual void | handleTriangle (const Domain &domain, Particle *P, double dt)
virtual void | handleRectangle (const Domain &domain, Particle *P, double dt)
virtual void | handlePlane (const Domain &domain, Particle *P, double dt)
virtual void | handleSphere (const Domain &domain, Particle *P, double dt)
virtual void | handleDisk (const Domain &domain, Particle *P, double dt)
Protected Member Functions inherited from osgParticle::DomainOperator
virtual | ~DomainOperator ()
DomainOperator & | operator= (const DomainOperator &)
virtual void | handlePoint (const Domain &, Particle *, double)
virtual void | handleLineSegment (const Domain &, Particle *, double)
virtual void | handleBox (const Domain &, Particle *, double)
void | computeNewBasis (const osg::Vec3 &, const osg::Vec3 &, osg::Vec3 &, osg::Vec3 &)
void | ignore (const std::string &func)
Protected Member Functions inherited from osgParticle::Operator
virtual | ~Operator ()
Operator & | operator= (const Operator &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

float | _friction
float | _resilience
float | _cutoff
Protected Attributes inherited from osgParticle::DomainOperator
std::vector< Domain > | _domains
std::vector< Domain > | _backupDomains
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A bounce operator can affect the particle's velocity to make it rebound. Refer to David McAllister's Particle System API (http://www.particlesystems.org)

## Constructor & Destructor Documentation

## BounceOperator() [1/2]

osgParticle::BounceOperator::BounceOperator | ( |  | ) |

inline

References _cutoff, _friction, _resilience, and osgParticle::DomainOperator::DomainOperator().

Referenced by BounceOperator(), META_Object(), and operator=().

## BounceOperator() [2/2]

osgParticle::BounceOperator::BounceOperator | ( | const BounceOperator & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _cutoff, _friction, _resilience, BounceOperator(), osgParticle::DomainOperator::DomainOperator(), and osg::CopyOp::SHALLOW_COPY.

## ~BounceOperator()

virtual osgParticle::BounceOperator::~BounceOperator | ( |  | ) |

inline protected virtual

## Member Function Documentation

## getCutoff()

float osgParticle::BounceOperator::getCutoff | ( |  | ) | const

inline

Get the velocity cutoff factor.

References _cutoff.

## getFriction()

float osgParticle::BounceOperator::getFriction | ( |  | ) | const

inline

Get the friction.

References _friction.

## getResilience()

float osgParticle::BounceOperator::getResilience | ( |  | ) | const

inline

Get the velocity cutoff factor.

References _resilience.

## handleDisk()

virtual void osgParticle::BounceOperator::handleDisk | ( | const Domain & | domain,
|  | Particle * | P,
|  | double | dt )

protected virtual

Reimplemented from osgParticle::DomainOperator.

## handlePlane()

virtual void osgParticle::BounceOperator::handlePlane | ( | const Domain & | domain,
|  | Particle * | P,
|  | double | dt )

protected virtual

Reimplemented from osgParticle::DomainOperator.

## handleRectangle()

virtual void osgParticle::BounceOperator::handleRectangle | ( | const Domain & | domain,
|  | Particle * | P,
|  | double | dt )

protected virtual

Reimplemented from osgParticle::DomainOperator.

## handleSphere()

virtual void osgParticle::BounceOperator::handleSphere | ( | const Domain & | domain,
|  | Particle * | P,
|  | double | dt )

protected virtual

Reimplemented from osgParticle::DomainOperator.

## handleTriangle()

virtual void osgParticle::BounceOperator::handleTriangle | ( | const Domain & | domain,
|  | Particle * | P,
|  | double | dt )

protected virtual

Reimplemented from osgParticle::DomainOperator.

## META_Object()

osgParticle::BounceOperator::META_Object | ( | osgParticle | ,
|  | BounceOperator | )

References BounceOperator().

## operator=()

BounceOperator & osgParticle::BounceOperator::operator= | ( | const BounceOperator & |  | ) |

inline protected

References BounceOperator().

## setCutoff()

void osgParticle::BounceOperator::setCutoff | ( | float | v | ) |

inline

Set the velocity cutoff factor.

References _cutoff.

## setFriction()

void osgParticle::BounceOperator::setFriction | ( | float | f | ) |

inline

Set the friction.

References _friction.

## setResilience()

void osgParticle::BounceOperator::setResilience | ( | float | r | ) |

inline

Set the resilience.

References _resilience.

## Member Data Documentation

## _cutoff

float osgParticle::BounceOperator::_cutoff

protected

Referenced by BounceOperator(), BounceOperator(), getCutoff(), and setCutoff().

## _friction

float osgParticle::BounceOperator::_friction

protected

Referenced by BounceOperator(), BounceOperator(), getFriction(), and setFriction().

## _resilience

float osgParticle::BounceOperator::_resilience

protected

Referenced by BounceOperator(), BounceOperator(), getResilience(), and setResilience().

The documentation for this class was generated from the following file:

- BounceOperator